/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


#include <iostream.h>
#include <stdio.h>

#include "sockrpc.hxx"
#include "connectdinfo.hxx"
#include "pollset.hxx"


void Terminate() {
}

int main(int argc, char *argv[])
{
  int YOOC_PORT = 0 ;
  int vers = 0 ;
  
  for (int i = 1; i < argc; i++) {
    if (strcmp(argv[i], "-p") == 0) {
      i++ ;
      YOOC_PORT = atoi(argv[i]) ;
    } else if (strcmp(argv[i], "-v") == 0) {
      vers = 1 ;
    } else {
      cerr << "usage : " << argv[0] << " [-v] [-p <port number>] " << endl ;
    }
  }

  if (YOOC_PORT == 0) {
    char* port = getenv("YOOC_PORT") ;
    if (port == NULL) {
      cerr << "no specified port number for " << argv[0] << endl ;
      cerr << "use -p option or YOOC_PORT environnement variable" << endl ;
      exit(1) ;
    }
    YOOC_PORT = atoi(port) ;
  }

  char master[256] ;
  char* dummy = getenv("YOOC_MASTER") ;
  if (dummy == NULL) {
    cerr << "no specified master host" << endl ;
    cerr << "set YOOC_MASTER environnement variable" << endl ;
    exit(1) ;
  } else {
    strcpy(master, dummy) ;
  }

  if (vers) {
    printf("YOODA version 1.2 <%s>, Copyright (C) 1994 Eric Abecassis
YOODA comes with ABSOLUTELY NO WARRANTY; for details type `COPYING'
in YOODA_HOME directory. This is free software, and you are welcome to 
redistribute it under certain conditions; for details read `COPYING'
or 'COPYING.LIB' in YOODA_HOME directory\n", argv[0]) ;
  }

  proxy(MasterConnectionD) svc; 
  char tohost[256] ;

  if (svc.importCless(master, YOOC_PORT) == -1) {
    cerr << "==> No master daemon found" << endl ;
    exit(1) ;
  }
  cerr << "connected to " << svc.tohost(tohost) << " " 
       << svc.toport() << "\n";
  
  ListVal<ConnectdInfo> conn_l ;
  svc.infoGlobal(conn_l) ;

  IterListVal<ConnectdInfo> iter(conn_l) ;
  for (; iter.more(); iter.next()) {
    cout << "Servers on host : " << iter.get().host << endl ;
    IterListVal<ServDescr> iter2(iter.get().serv_l) ;
    for (; iter2.more(); iter2.next()) {
      cout << "\tServer <" << iter2.get().service() << ">" << endl ;
      cout << "\t\tfilter => " << iter2.get().filter() << endl ;
      cout << "\t\tport   => " << iter2.get().port() << endl ;
      if (iter2.get().isFree()) {
	cout << "\t\tstate   => available" << endl ;
      } else {
	cout << "\t\tstate   => in use" << endl ;
      }
    }
  }
}
